/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2010 France Telecom R&D
 * Contact: jonas-team@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 *
 * --------------------------------------------------------------------------
 * $Id: MyAsyncHandlerImpl.java 21401 2011-06-08 21:37:00Z jppouzol $
 * --------------------------------------------------------------------------
 */

package org.ow2.jonas.cxf.transport.reliablejms.example.ejbmdb;

import org.ow2.jonas.cxf.transport.reliablejms.api.AsyncHandler;
import org.ow2.jonas.cxf.transport.reliablejms.api.ContextInfo;

public class MyAsyncHandlerImpl implements AsyncHandler {

    /**
     * Handler needs to persist the given correlation ID given by the client emitter.
     * @param contextInfo data about the invocation like the correlation ID, endpoint name, etc.
     */
    public void saveContext(ContextInfo contextInfo) {
        // persist to database
        System.out.println("Calling " + this + " saveContext " + contextInfo);
    }

    /**
     * @param contextInfo data about the invocation like the correlation ID, endpoint name, etc.
     * @return true if the given ID is matching one of our IDs
     */
    public boolean doYouKnowThisContext(ContextInfo contextInfo) {
        System.out.println("Calling " + this + " doYouKnowThisContext " + contextInfo);

        return true;
    }

    /**
     * Response to handle if doYouKnowThisID() call was successful.
     * @param response the response object
     * @param contextInfo data about the invocation like the correlation ID, endpoint name, etc.
     */
    public void doHandlerResponse(Object response, ContextInfo contextInfo) {
        System.out.println("Calling " + this + " doHandlerResponse " + contextInfo);
        System.out.println("Response is : " + response);
    }

    /**
     * Handle a given fault
     * @param exception the exception object
     * @param contextInfo data about the invocation like the correlation ID, endpoint name, etc.
     */
    public void doHandlerFault(Throwable exception, ContextInfo contextInfo) {
        System.out.println("Calling " + this + " doHandlerFault " + contextInfo);
        System.out.println("exception is : " + exception);
    }
}